using MicroFour.StrataFrame.Business;
using MicroFour.StrataFrame.Security;
using MicroFour.StrataFrame.UI.Windows.Forms;
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.IO;

namespace VerySimpleApp2
{
    public partial class NullTestBO
    {

        #region Component Implementation

        /// <summary>
        /// Required designer variable.
        /// </summary>
        private System.ComponentModel.IContainer components = null;

        /// <summary> 
        /// Clean up any resources being used.
        /// </summary>
        /// <param name="disposing">true if managed resources should be disposed; otherwise, false.</param>
        protected override void Dispose(bool disposing)
        {
            if (disposing && (components != null))
            {
                components.Dispose();
            }
            base.Dispose(disposing);
        }

        /// <summary>
        /// Required method for Designer support - do not modify
        /// the contents of this method with the code editor.
        /// </summary>
        private void InitializeComponent()
        {
            components = new System.ComponentModel.Container();

            this.CheckRulesOnCurrentRow += new CheckRulesOnCurrentRowEventHandler(NullTestBO_CheckRulesOnCurrentRow);
            this.SetDefaultValues += new SetDefaultValuesEventHandler(NullTestBO_SetDefaultValues);
        }

        #endregion


        #region BusinessLayer Overriden Methods & Properties

        /// <summary>
        /// The collection of required fields for the business object.
        /// </summary>
        /// <remarks></remarks>
        [Browsable(false), DesignerSerializationVisibility(DesignerSerializationVisibility.Hidden)]
        public override RequiredFieldsCollection RequiredFields
        {
            get
            {
                return base.RequiredFields;
            }
            set
            {
                base.RequiredFields = value;
            }
        }

        /// <summary>
        /// Defines the constraint that defines the parent-child relationship between this business object type and another business object type.
        /// </summary>
        /// <remarks></remarks>
        [Browsable(false), DesignerSerializationVisibility(DesignerSerializationVisibility.Hidden)]
        public override IBusinessParentRelationship ParentRelationship
        {
            get
            {
                return base.ParentRelationship;
            }
            set
            {
                base.ParentRelationship = value;
            }
        }

        /// <summary>
        /// Returns all of the field names in a single string in the form of [field1],[field2],...  This must be used in the place of '*' in select statements if Query Notifications are to be registered.
        /// </summary>
        /// <remarks></remarks>
        protected override String AllFieldNames
        {
            get
            {
                return "[NULL_TEST_PK],[NULL_TEST_VALUE]";
            }
        }

        /// <summary>
        /// The name of the database that contains the table to which this business object is mapped.
        /// </summary>
        /// <remarks></remarks>
        public override String Database
        {
            get
            {
                return "GEO";
            }
        }

        private static string[] _PrimaryKeyFields = new string[] { "NULL_TEST_PK" };
        /// <summary>
        /// Gets the field or fields that comprise the primary key for the business object.
        /// </summary>
        /// <remarks></remarks>
        public override string[] PrimaryKeyFields
        {
            get
            {
                return _PrimaryKeyFields;
            }
        }

        /// <summary>
        /// The name of the table in the database to which this business object is mapped.
        /// </summary>
        /// <remarks></remarks>
        public override String TableName
        {
            get
            {
                return "NULL_TEST";
            }
        }

        /// <summary>
        /// The schema of the table in the database to which this business object is mapped.
        /// </summary>
        /// <remarks></remarks>
        public override String TableSchema
        {
            get
            {
                return "GEO";
            }
        }

        /// <summary>
        /// Creates and returns an array of DataColumns that contains the schema for the table.  This is used to prevent a round trip to the server to aquire the initial schema for the internal DataTable.
        /// </summary>
        /// <remarks></remarks>
        protected override DataColumn[] CreateTableSchema()
        {
            return new DataColumn[] {
new DataColumn("NULL_TEST_PK", typeof(System.Decimal)),
new DataColumn("NULL_TEST_VALUE", typeof(System.Decimal))};
        }

        /// <summary>
        /// Adds a broken rule to the business object's collection
        /// </summary>
        /// <remarks></remarks>
        protected void AddBrokenRule(NullTestBOFieldNames Field, string ErrorMessage)
        {
            base.AddBrokenRule(Field, ErrorMessage);
        }

        /// <summary>
        /// Adds a broken rule to the business object's collection
        /// </summary>
        /// <remarks></remarks>
        protected new void AddBrokenRule(string FieldName, string ErrorMessage)
        {
            base.AddBrokenRule(FieldName, ErrorMessage);
        }

        /// <summary>
        /// Adds a broken rules to the business object's collection using the given message key to pull the error message from the localization database
        /// </summary>
        /// <remarks></remarks>
        protected void AddBrokenRuleByKey(NullTestBOFieldNames Field, string ErrorMessageKey)
        {
            base.AddBrokenRuleByKey(Field, ErrorMessageKey);
        }

        /// <summary>
        /// Adds a broken rules to the business object's collection using the given message key to pull the error message from the localization database
        /// </summary>
        /// <remarks></remarks>
        protected new void AddBrokenRuleByKey(string FieldName, string ErrorMessageKey)
        {
            base.AddBrokenRuleByKey(FieldName, ErrorMessageKey);
        }

        /// <summary>
        /// Gets a collection of the names for all fields that belong to this business object and map to the database.
        /// </summary>
        /// <remarks></remarks>
        public override List<string> AllFieldsList
        {
            get
            {
                return _AllFieldsList;
            }
        }

        /// <summary>
        /// Gets a dictionary of the DbTypes for all fields that belong to this business object and map to the database.
        /// </summary>
        /// <remarks></remarks>
        public override Dictionary<string, DbType> FieldDbTypes
        {
            get
            {
                return _FieldDbTypes;
            }
        }

        /// <summary>
        /// Gets a dictionary of all fields within this business object that map to the FieldNames enumeration for this business object.
        /// </summary>
        /// <remarks></remarks>
        public override BusinessLayerFieldEnumDictionary FieldEnums
        {
            get
            {
                return _FieldEnums;
            }
        }

        /// <summary>
        /// Gets a dictionary of all of the lengths for all fields within this business object that map to a field in the database.
        /// </summary>
        /// <remarks></remarks>
        public override Dictionary<string, int> FieldLengths
        {
            get
            {
                return _FieldLengths;
            }
        }

        /// <summary>
        /// Gets a dictionary of the native DbType (SqlDbType, OracleType, OleDbType, etc.) for all fields within this buisness object that map to a field in the database.
        /// </summary>
        /// <remarks></remarks>
        public override Dictionary<string, int> FieldNativeDbTypes
        {
            get
            {
                return _FieldNativeDbTypes;
            }
        }

        /// <summary>
        /// Gets a dictionary of the security permission keys for each field in the business object.
        /// </summary>
        /// <remarks></remarks>
        public override Dictionary<string, string> FieldPermissionKeys
        {
            get
            {
                return _FieldPermissionKeys;
            }
        }

        #endregion

        #region Field Properties

        /// <summary>
        /// NULL_TEST_PK
        /// </summary>
        /// <remarks></remarks>
        [Browsable(false),
         BusinessFieldDisplayInEditor(),
         Description("NULL_TEST_PK"),
         DesignerSerializationVisibility(DesignerSerializationVisibility.Hidden)]
        public System.Decimal NULL_TEST_PK
        {
            get
            {
                NullTestBOFieldAccessingEventArgs e;
                System.Decimal loReturn;
                loReturn = (System.Decimal)this.CurrentRow["NULL_TEST_PK"];
                e = new NullTestBOFieldAccessingEventArgs(NullTestBOFieldNames.NULL_TEST_PK, loReturn);
                this.OnFieldPropertyAccessing(this, e);
                return (System.Decimal)e.ValueToReturn;
            }
            set
            {
                this.CurrentRow["NULL_TEST_PK"] = value;
            }
        }

        /// <summary>
        /// NULL_TEST_VALUE
        /// </summary>
        /// <remarks></remarks>
        [Browsable(false),
         BusinessFieldDisplayInEditor(),
         Description("NULL_TEST_VALUE"),
         DesignerSerializationVisibility(DesignerSerializationVisibility.Hidden)]
        public Nullable<System.Decimal> NULL_TEST_VALUE
        {
            get
            {
                object loValue;
                NullTestBOFieldAccessingEventArgs e;
                Nullable<System.Decimal> loReturn;
                loValue = this.CurrentRow["NULL_TEST_VALUE"];
                if (loValue == DBNull.Value)
                {
                    loReturn = (Nullable<System.Decimal>)null;
                }
                else
                {
                    loReturn = new Nullable<System.Decimal>((System.Decimal)loValue);
                }
                e = new NullTestBOFieldAccessingEventArgs(NullTestBOFieldNames.NULL_TEST_VALUE, loReturn);
                this.OnFieldPropertyAccessing(this, e);
                return new Nullable<System.Decimal>((System.Decimal)(e.ValueToReturn));
            }
            set
            {
                if (value.HasValue)
                {
                    this.CurrentRow["NULL_TEST_VALUE"] = value.Value;
                }
                else
                {
                    this.CurrentRow["NULL_TEST_VALUE"] = DBNull.Value;
                }
            }
        }

        #endregion

        #region Field Property Events

        /// <summary>
        /// Represents a method that will handle the FieldPropertyAccessing event.
        /// </summary>
        /// <remarks></remarks>
        public delegate void NullTestBOFieldPropertyAccessingEventHandler(object sender, NullTestBOFieldAccessingEventArgs e);
        /// <summary>
        /// Occurs when a field property is accessing.
        /// </summary>
        /// <remarks></remarks>
        public event NullTestBOFieldPropertyAccessingEventHandler FieldPropertyAccessing
        {
            add
            {
                this.AddEventHandler("FieldPropertyAccessing", value);
            }
            remove
            {
                this.RemoveEventHandler("FieldPropertyAccessing", value);
            }
        }
        /// <summary>
        /// Raises the OnFieldPropertyAccessing event.
        /// </summary>
        /// <remarks></remarks>
        private void OnFieldPropertyAccessing(object sender, NullTestBOFieldAccessingEventArgs e)
        {
            NullTestBOFieldPropertyAccessingEventHandler loHandler;
            loHandler = (NullTestBOFieldPropertyAccessingEventHandler)this.GetEventHandler("FieldPropertyAccessing");
            if (loHandler != null)
            {
                loHandler.Invoke(sender, e);
            }
        }

        #endregion

        #region Nested Types & Field Security

        public class NullTestBOFieldAccessingEventArgs : FieldPropertyAccessingEventArgs
        {

            public NullTestBOFieldAccessingEventArgs(NullTestBOFieldNames FieldAccessing, object Value) : base(FieldAccessing, Value) { }

            public NullTestBOFieldNames FieldAccessing
            {
                get
                {
                    return (NullTestBOFieldNames)base.Field;
                }
            }

        }

        /// <summary>
        /// Contains all of the field names that belong to the business object.
        /// </summary>
        /// <remarks></remarks>
        public enum NullTestBOFieldNames
        {
            NULL_TEST_PK,
            NULL_TEST_VALUE,
            CUSTOM_FIELD
        }

        /// <summary>
        /// Gets the System.Type of the enumeration that contains the field names for the business object.
        /// </summary>
        /// <remarks></remarks>
        public override System.Type GetFieldEnumType()
        {
            return typeof(NullTestBOFieldNames);
        }

        /// <summary>
        /// Creates a new CheckFieldSecurityEventArgs object that can be used with this business object type.
        /// </summary>
        /// <remarks></remarks>
        protected override CheckFieldSecurityEventArgsBase CreateNewFieldSecurityEventArgs(System.Enum Field, string CustomField, string PermissionKey, PermissionInfo Perm)
        {
            return new CheckFieldSecurityEventArgs<NullTestBOFieldNames>(Field, CustomField, PermissionKey, Perm);
        }

        /// <summary>
        /// Describes a method that will handle the CheckFieldScurity event.
        /// </summary>
        /// <remarks></remarks>
        public delegate void CheckFieldSecurityEventHandler(object sender, CheckFieldSecurityEventArgs<NullTestBOFieldNames> e);

        /// <summary>
        /// Occurs when the business objects needs to check the security on a field.
        /// </summary>
        /// <remarks></remarks>
        public event CheckFieldSecurityEventHandler CheckFieldSecurity;

        /// <summary>
        /// Raises the CheckFieldSecurity event.
        /// </summary>
        /// <remarks></remarks>
        protected override void OnCheckFieldSecurity(CheckFieldSecurityEventArgsBase e)
        {
            if (this.CheckFieldSecurity != null)
            {
                this.CheckFieldSecurity(this, (CheckFieldSecurityEventArgs<NullTestBOFieldNames>)e);
            }
        }

        #endregion

        #region Item Property Implementation


        private static List<string> _AllFieldsList;
        private static Dictionary<string, DbType> _FieldDbTypes;
        private static BusinessLayerFieldEnumDictionary _FieldEnums;
        private static Dictionary<string, int> _FieldLengths;
        private static Dictionary<string, int> _FieldNativeDbTypes;
        private static Dictionary<string, string> _FieldPermissionKeys;

        /// <summary>
        /// Initializes the static members of the NullTestBO class.
        /// </summary>
        /// <remarks></remarks>
        static NullTestBO()
        {
            //-- Create the new shared dictionary and populate it with an 
            //   instance of each property descriptor
            _PropertyDescriptors = new PropertyDescriptorDictionary(7);
            _PropertyDescriptors.Add("NULL_TEST_PK", new Field_NULL_TEST_PK_Descriptor());
            _PropertyDescriptors.Add("NULL_TEST_VALUE", new Field_NULL_TEST_VALUE_Descriptor());

            _AllFieldsList = new List<string>(2);
            _AllFieldsList.Add("NULL_TEST_PK");
            _AllFieldsList.Add("NULL_TEST_VALUE");

            _FieldDbTypes = new Dictionary<string, DbType>(2);
            _FieldDbTypes.Add("NULL_TEST_PK", DbType.VarNumeric);
            _FieldDbTypes.Add("NULL_TEST_VALUE", DbType.VarNumeric);

            _FieldEnums = new BusinessLayerFieldEnumDictionary(3);
            _FieldEnums.Add("NULL_TEST_PK", NullTestBOFieldNames.NULL_TEST_PK);
            _FieldEnums.Add("NULL_TEST_VALUE", NullTestBOFieldNames.NULL_TEST_VALUE);
            _FieldEnums.Add("CUSTOM_FIELD", NullTestBOFieldNames.CUSTOM_FIELD);

            _FieldLengths = new Dictionary<string, int>(2);
            _FieldLengths.Add("NULL_TEST_PK", 0);
            _FieldLengths.Add("NULL_TEST_VALUE", 0);

            _FieldNativeDbTypes = new Dictionary<string, int>(2);
            _FieldNativeDbTypes.Add("NULL_TEST_PK", (int)System.Data.OracleClient.OracleType.Number);
            _FieldNativeDbTypes.Add("NULL_TEST_VALUE", (int)System.Data.OracleClient.OracleType.Number);

            _FieldPermissionKeys = new Dictionary<string, string>(2);

        }

        private static bool _AreCustomDescriptorsEvaluated = false;
        protected override bool AreCustomDescriptorsEvaluated
        {
            get
            {
                bool llReturn = _AreCustomDescriptorsEvaluated;
                _AreCustomDescriptorsEvaluated = true;
                return llReturn;
            }
        }

        private static PropertyDescriptorDictionary _PropertyDescriptors;
        protected override PropertyDescriptorDictionary PropertyDescriptors
        {
            get
            {
                return _PropertyDescriptors;
            }
        }

        /// <summary>
        /// A private field used to store the System.Type of this business object for use by the FieldPropertyDescriptor classes.
        /// </summary>
        /// <remarks></remarks>

        private static System.Type _ComponentType = typeof(NullTestBO);

        /// <summary>
        /// A PropertyDescriptor class used to Get and Set the value of the NULL_TEST_PK property.
        /// </summary>
        /// <remarks></remarks>
        private class Field_NULL_TEST_PK_Descriptor : MicroFour.StrataFrame.Business.FieldPropertyDescriptor
        {
            public Field_NULL_TEST_PK_Descriptor() : base("NULL_TEST_PK") { }
            private System.Type _PropertyType = typeof(System.Decimal);
            public override object GetValue(Object component)
            {
                return ((NullTestBO)component).NULL_TEST_PK;
            }
            public override void SetValue(Object component, object Value)
            {
                ((NullTestBO)component).NULL_TEST_PK = (System.Decimal)Value;
            }
            public override System.Type PropertyType
            {
                get
                {
                    return this._PropertyType;
                }
            }
            public override System.Type ComponentType
            {
                get
                {
                    return _ComponentType;
                }
            }
        }

        /// <summary>
        /// A PropertyDescriptor class used to Get and Set the value of the NULL_TEST_VALUE property.
        /// </summary>
        /// <remarks></remarks>
        private class Field_NULL_TEST_VALUE_Descriptor : MicroFour.StrataFrame.Business.FieldPropertyDescriptor
        {
            public Field_NULL_TEST_VALUE_Descriptor() : base("NULL_TEST_VALUE") { }
            private System.Type _PropertyType = typeof(System.Decimal);
            public override object GetValue(Object component)
            {
                return ((NullTestBO)component).NULL_TEST_VALUE;
            }
            public override void SetValue(Object component, object Value)
            {
                ((NullTestBO)component).NULL_TEST_VALUE = (Nullable<System.Decimal>)Value;
            }
            public override System.Type PropertyType
            {
                get
                {
                    return this._PropertyType;
                }
            }
            public override System.Type ComponentType
            {
                get
                {
                    return _ComponentType;
                }
            }
        }

        #endregion

    }

}
